#  This software was derived from SATAN 1.1.1 by Dan Farmer and Wietse Venema
#  (http://www.porcupine.org/satan).
#
#  This code update is provided by the Advanced Research Corporation (r) to
#  further the utility of the SARA Report Writer.  We request that the
#  developers do not modify or reverse engineer this code for
#  their own gain.
#
#  Developed and distributed by the Advanced Research Corporation.
#
# Report subnets
#
# generate the tables for looking subnets/hosts in:

&make_subnet_info();
$_subnets = keys %all_subnets;
sub sort_ip {
    local($aip,$bip);
    for $ip (split(/\./,$a)) { $aip = $aip * 256 + $ip; }
    for $ip (split(/\./,$b)) { $bip = $bip * 256 + $ip; }
    return $aip <=> $bip;
}

print <<EOF;
<HTML>
<HEAD>
<title>Database by CSV </title>
<LINK REV="made" HREF="mailto:satan\@fish.com">
<LINK REV="made" HREF="mailto:sara\@arc.com">
</HEAD>
<H2>Security Auditor's Research Assistant (SARA) ReportWriter</H2>
<a href="$HTML_ROOT/$system.html"> Back to the $SYSTEM start page </a> |
<a href="$HTML_SERVER/reporting/analysis.pl"> Back to $SYSTEM Reporting and Analysis </a><HR>
EOF
#
#  Get History Information
#
$black_bar=0;
$green_bar=0;
$red_bar=0;
$yellow_bar=0;
$brown_bar=0;
$start_report=0;
$report="chart";
open (CSV, ">results/$sara_data/report.csv");
if ( $interactive eq "ON") {
  print "<P><H3>CSV Results at ./results/$sara_data/report.csv</H3><P>";
  print '<TABLE WIDTH = 1000 BORDER = 3>';
  print '<TR><TD><B><CENTER>Host</Center></B></TD>';
  print '<TD><B><CENTER>NB</Center></B></TD>';
  print '<TD><B><CENTER>IP</Center></B></TD>';
  print '<TD><B><CENTER>OS</Center></B></TD>';
  print '<TD><B><CENTER>Vul Category</Center></B></TD>';
  print '<TD><B><CENTER>Vul Severity</Center></B></TD>';
  print '<TD><B><CENTER>Description</Center></B></TD>';
  print '<TD><B><CENTER>Database</Center></B></TD>';
  print '<TD><B><CENTER>Scan Date</Center></B></TD></TD>';
  print '<TD><B><CENTER>False Positive</Center></B></TD>';
  print '<TD><B><CENTER>Administrator</Center></B></TD>' if $get_admins == 1;
}
for $_net (sort sort_ip keys %all_subnets)
{
  @_hosts = split(/\s/, $all_subnets{$_net});
  if ($_net ne "unknown") {
   do "$html_root/reporting/reportwriter/report_csv.pl";
  }
}
print '</TABLE>/'if ($interactive = "ON");
close (CSV);
