#  This software was derived from SATAN 1.1.1 by Dan Farmer and Wietse Venema
#  (http://www.porcupine.org/satan).
#
#
# Show information about a specific host.
#
($_host) = split(/,/, $html_script_args);
($_type = $hosttype{$_host}) =~ tr / \//+!/;

print CLIENT <<EOF;
<HTML>
<HEAD>
<SCRIPT language="JavaScript">
  function movepic(img_name,img_src) {
  document[img_name].src=img_src;
}
</SCRIPT>
<title> Results - $_host </title>
<LINK REV="made" HREF="mailto:satan\@fish.com">
<LINK REV="updated" HREF="mailto:sara\@arc.com">
</HEAD>
<BODY>
EOF
if ($pi_menu) {
  $screen = &$pi_menu;
} else {
  $screen = print_menu();
}
$screen =~ s/\\n/\n/g;
print CLIENT $screen;
print CLIENT <<EOF;
</TD><TD valign=top>
<CENTER><H1>Results - $_host </H1></CENTER>
<hr>
<h3>General host information:</h3>
<ul>
EOF

#
# Refresh the host type and service tables.
#
&make_hosttype_info();
&make_service_info();
&make_subnet_info();
&make_severity_info();

$_exists = 0;
$_dot = "blackdot";
$_alt = "BLACK";

if (exists($hosttype{$_host})) {
	print CLIENT <<EOF;
        <dt><IMG SRC="$HTML_ROOT/dots/$_dot.gif" ALT="$_alt">
	Host type: <A HREF="sara_info_OStype.pl,$_type,">$hosttype{$_host}</A>
EOF
	$_exists = 1;
}

if (exists($server_info{$_host})) {
	for (sort split(/\n/, $server_info{$_host})) {
		# Mask blanks and slashes
		($_service = $_) =~ tr / \//+!/;
                $_dot = "greendot";
                if ($_service =~ "SMB") {
                  open (NB, $facts_file);
                  while (<NB>) {
                    chop;
                    if (/Netbios Name/ && /$_host/) {
                     @nb=split(/\|/,$_);
                     $nbname="($nb[7])";
                    }
                }
                close(NB);
                $_="SMB";
                } else {
                  $nbname="";
                }
		print CLIENT <<EOF;
                <dt><IMG SRC="$HTML_ROOT/dots/$_dot.gif" ALT="$_alt">
		<A HREF="sara_info_servers.pl,$_service,"> $_ </A> server $nbname
EOF
	}
	$_exists = 1;
}

if (exists($client_info{$_host})) {
	for (sort split(/\n/, $client_info{$_host})) {
		# Mask blanks and slashes
		($_service = $_) =~ tr / \//+!/;
		print CLIENT <<EOF;
                <dt><IMG SRC="$HTML_ROOT/dots/$_dot.gif" ALT="$_alt">
		<A HREF="sara_info_clients.pl,$_service,"> $_ </A> client
EOF
	}
	$_exists = 1;
}

if (exists($all_hosts{$_host})) {
	($_subnet = $all_hosts{$_host}{IP}) =~ s/\.[^.]*$//;
        $_dot = "blackdot";
	print CLIENT <<EOF;
        <dt><IMG SRC="$HTML_ROOT/dots/$_dot.gif" ALT="$_alt">
	Subnet <A HREF="sara_results_subnet.pl,$_subnet,"> $_subnet </A>
EOF
	$_exists = 1;
}

if (exists($total_trustee_count{$_host})) {
	$_count = split(/\s+/, $total_trustee_names{$_host});
	print CLIENT <<EOF;
        <dt><IMG SRC="$HTML_ROOT/dots/$_dot.gif" ALT="$_alt">
	$_count
	<A HREF="sara_results_trusting.pl,$_host,trustee_type,"> Trusting host(s) </a>
EOF
	$_exists = 1;
}

if (exists($total_trusted_count{$_host})) {
	$_count = split(/\s+/, $total_trusted_names{$_host});
	print CLIENT <<EOF;
        <dt><IMG SRC="$HTML_ROOT/dots/$_dot.gif" ALT="$_alt">
	$_count
	<A HREF="sara_results_trusted.pl,$_host,trusted_type,"> Trusted host(s) </a>
EOF
	$_exists = 1;
}

if (exists($all_hosts{$_host}) && defined($all_hosts{$_host}{'attack'})) {
	@_level = ('none', 'light', 'normal', 'heavy', 'all out');
	print CLIENT <<EOF;
        <dt><IMG SRC="$HTML_ROOT/dots/$_dot.gif" ALT="$_alt">
	Scanning level: @_level[1 + $all_hosts{$_host}{'attack'}]
EOF
	$_exists = 1;
}

if (exists($all_hosts{$_host}) && defined($all_hosts{$_host}{'time'})
	&& $all_hosts{$_host}{'time'} > 1) {
	$_time = &ctime($all_hosts{$_host}{'time'});
	print CLIENT <<EOF;
        <dt><IMG SRC="$HTML_ROOT/dots/$_dot.gif" ALT="$_alt">
	Last scan: $_time
EOF
	$_exists = 1;
}


print CLIENT "</ul>\n";

if (exists($severity_host_type_info{$_host})) {
	print CLIENT "<h3>Vulnerability information:</h3><ul>\n";
	for (keys %{$severity_host_type_info{$_host}}) {
		($_tutorials = $_) =~ tr / /_/;
		for (sort split(/\n/, $severity_host_type_info{$_host}{$_})) {
	   	       &sara_split($_);
                         if($severity_brown_type_info{$service_output}) {
                            $_dot = "browndot";
                            $_alt = "BROWN";
                         } elsif ($severity_green_type_info{$service_output}) {
                            $_dot = "greendot";
                            $_alt = "GREEN";
                         } elsif ($severity_yellow_type_info{$service_output}) {
                            $_dot = "yellowdot";
                            $_alt = "YELLOW";
                         } elsif ($severity_red_type_info{$service_output}) {
                            $_dot = "reddot";
                            $_alt = "RED";
                         } else {
#                            $_dot = "blackdot";
                         }
			print CLIENT <<EOF;
        <dt><IMG SRC="$HTML_ROOT/dots/$_dot.gif" ALT="$_alt">
	<A HREF="$HTML_ROOT/tutorials/vulnerability/$_tutorials.html">$text</A>
EOF
		}
	}
	$_exists = 1;
}
print CLIENT <<EOF;
</ul>
EOF

# List host service info

if ($_exists) {
        $_dot = "blackdot";
	print CLIENT <<EOF;
	<h3>Actions:</h3> <ul>
        <dt><IMG SRC="$HTML_ROOT/dots/$_dot.gif" ALT="$_alt">
	<A HREF="$HTML_SERVER/running/sara_run_form.pl,$_host,">Scan this host</a>
EOF
} else {
	print CLIENT <<EOF;
	<h3>No information found on host $_host.</h3>
EOF
}

print CLIENT <<EOF;
<hr> <a href=$HTML_SERVER> Back to the SARA start page </a> |
<a href=$HTML_SERVER/reporting/analysis.pl> Back to SARA Reporting and Analysis </a>
</UL></UL></TABLE>
</BODY>
</HTML>
EOF
