;# getopts.pl - a better getopt.pl

;# Usage:
;#      do Getopts('a:bc');  # -a takes arg. -b & -c not. Sets opt_* as a
;#                           #  side effect.
sub Getopts {
    local($argumentative) = @_;
    local(@args,$_,$first,$rest);
    local($errs) = 0;
    local($[) = 0;

    @args = split( / */, $argumentative );
    while(@ARGV && ($_ = $ARGV[0]) =~ /^-(.)(.*)/) {
	($first,$rest) = ($1,$2);
	$pos = index($argumentative,$first);
	if($pos >= $[) {
	    if($args[$pos+1] eq ':') {
		shift(@ARGV);
		if($rest eq '') {
		    ++$errs unless @ARGV;
		    $rest = shift(@ARGV);
		}
		eval "\$opt_$first = \$rest;";
	    }
	    else {
		eval "\$opt_$first = 1";
		if($rest eq '') {
		    shift(@ARGV);
		}
		else {
		    $ARGV[0] = "-$rest";
		}
	    }
	}
	else {
	    print STDERR "Unknown option: $first\n";
	    ++$errs;
	    if($rest ne '') {
		$ARGV[0] = "-$rest";
	    }
	    else {
		shift(@ARGV);
	    }
	}
    }
    $errs == 0;
}

1;

sub sans10 {
local($arg) = @_;
$sans_label = "";
return 1 if $sans ne "on";
$sans_version = 1;
$sans_type = "SANS TOP 10";
$sans_url = "http://www.sans.org/topten.htm";
$sans_file = "config/sans10.r1";
if (-f "config/sans10.r2") {
  $sans_version = 2;
  $sans_type = "SANS TOP 20";
  $sans_url = "http://www.sans.org/topten-2.htm";
  $sans_file = "config/sans10.r2";
}
return 1 if ! -f $sans_file;
if (! @sans_vul) {
   $cnt = 0;
   open (SANS, $sans_file);
   while (<SANS>) {
     chomp;
     if (($_ !~ /^#/) || (! $_)) {
       ($sans_vul[$cnt], $sans_dscr0[$cnt]) = split(/\|/);
       $cnt++;
     }
   }
}
   $i = 0;
   for $test (@sans_vul) {
     if ($test eq $arg) {
       if ($sans_dscr0[$i]) {
         $sans_url = "$sans_dscr0[$i]" if $sans_version == 2;
         $sans_label = "<A HREF=$sans_url>$sans_type</A>";
       }
       return 1;
     }
     $i++;
   }
   return 0;
}
#
# Routine to compare to-be-reported vulnerabilities with the
# corrections file to determine if Reporter should report it.
# args are $target and $text
#
sub correction {
  local($arg) = @_;
  ($mytarget,$mykeyword) = split(/\|/,$arg);
  $corrections_file = "rules/correct_report";
  return 0 if $correction ne "on" || $option eq "default";
  return 0 if ! -f $corrections_file;
  open (CORRECTION, $corrections_file);
  while (<CORRECTION>) {
   chomp;
    if (($_ !~ /^#/) || (! $_)) {
    ($nexttarget,$nextkeyword,$nextadmin,$nextdate) = split(/\|/,$_);
     if( $nextadmin ne "" && $nextdate ne "") {
      return 1 if ( $nexttarget =~ /$mytarget/ && $mykeyword =~ /$nextkeyword/);
     }
    }
  }
  return 0;
}
